// DtvEngine.h: CDtvEngine NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "BonSrcDecoder.h"
#include "TsPacketParser.h"
#include "TsDescrambler.h"
#include "ProgManager.h"
#include "MediaViewer.h"
#include "MediaTee.h"
#include "FileWriter.h"
#include "FileReader.h"

// ̕ӂ͑S̎bł


//////////////////////////////////////////////////////////////////////
// fW^TVGWNX
//////////////////////////////////////////////////////////////////////

class CDtvEngineHandler;

class CDtvEngine : protected CMediaDecoder::IEventHandler
{
public:
	CDtvEngine(void);
	~CDtvEngine(void);

	const bool OpenEngine(CDtvEngineHandler *pDtvEngineHandler, HWND hHostHwnd,HWND hMessageDrainHwnd,HMODULE hBonDrvDll,bool bDescramble=true);
	const bool CloseEngine(void);
	const bool ResetEngine(void);
	
	const bool EnablePreview(const bool bEnable = true);
	const bool SetViewSize(const int x,const int y);
	const bool SwitchFullscreen();
	const bool SetVolume(const float fVolume);
	const bool GetVideoSize(WORD *pwWidth,WORD *pwHeight);
	const bool GetVideoAspectRate(WORD *pwAspectRateX,WORD *pwAspectRateY);

	const bool SetChannel(const BYTE byTuningSpace, const WORD wChannel);
	const bool SetService(const WORD wService);
	const WORD GetService(void) const;
	
	const bool PlayFile(LPCTSTR lpszFileName);
	void StopFile(void);
	
	const DWORD GetLastError(void) const;

//protected:
	const DWORD SendDtvEngineEvent(const DWORD dwEventID, PVOID pParam = NULL);
	virtual const DWORD OnDecoderEvent(CMediaDecoder *pDecoder, const DWORD dwEventID, PVOID pParam);

	// IMediaDecoder hfBAfR[_NX
	CBonSrcDecoder m_BonSrcDecoder;			// TS\[X`[i[(HALׂ)
	CTsPacketParser m_TsPacketParser;		// TSpPb^CU[
	CTsDescrambler m_TsDescrambler;			// TSfXNu[
	CProgManager m_ProgManager;				// TSvO}l[W[
	CMediaViewer m_MediaViewer;				// fBAr[A[
	CMediaTee m_MediaTee;					// fBAeB[
	CFileWriter m_FileWriter;				// t@CC^[
	CFileReader m_FileReader;				// t@C[_[

	CDtvEngineHandler *m_pDtvEngineHandler;
	WORD m_wCurTransportStream;
	WORD m_wCurService;
	WORD m_wCurAspectRateX;
	WORD m_wCurAspectRateY;

	bool m_bIsFileMode;
};


//////////////////////////////////////////////////////////////////////
// fW^TVCxgnhC^tF[X
//////////////////////////////////////////////////////////////////////

// ͏z֐Ƃׂ
class CDtvEngineHandler
{
friend CDtvEngine;

protected:
	virtual const DWORD OnDtvEngineEvent(CDtvEngine *pEngine, const DWORD dwEventID, PVOID pParam);
};
